<template>
  <div v-if="recaptchaPublicKey" class="vform-recaptcha mb-2">
    <vue-recaptcha :sitekey="recaptchaPublicKey" @verify="onVerify" />
    <div class="text-danger" v-if="error">{{ error }}</div>
  </div>
</template>

<script>
// Adapted from
// https://stackoverflow.com/questions/43890035/vue-js-google-recaptcha-callback

import { ref } from 'vue'
import VueRecaptcha from 'vue3-recaptcha2'
import { useVFormControl } from '../../plugins/vform-plugin.js'
import { useVForm } from '../../plugins/vform-plugin.js'

export default {
  name: 'VFormRecaptcha',
  props: {
    formName: { type: String, required: true },
    field: { type: Object, required: true },
    fieldPrefix: { type: String, required: true },
    modelState: { type: Object, default: null }, // Taken from the API response if validation fails at the server.
    busy: { type: Boolean, default: false },
  },
  components: {
    VueRecaptcha,
  },
  setup(props, context) {
    const baseProperties = useVFormControl(props, context)

    const vform = useVForm()

    const widgetId = ref(0)
    const recaptchaPublicKey = ref(vform.recaptchaPublicKey)

    const onVerify = (response) => {
      const mutatedfield = JSON.parse(JSON.stringify(props.field))
      mutatedfield.value = response

      context.emit('fieldInput', mutatedfield)
    }

    return {
      ...baseProperties,
      widgetId,
      recaptchaPublicKey,
      onVerify,
    }
  },
}
</script>
